import _extends from "@babel/runtime/helpers/esm/extends";

/**
 * Dependency imports
 */
import React from 'react';
import { Provider as ReduxProvider } from 'react-redux';
/**
 * Local imports
 */

import store from './store';
/**
 * Wrapper component for react-redux Provider with the store already passed in.
 */

var Provider = function Provider(props) {
  return /*#__PURE__*/React.createElement(ReduxProvider, _extends({
    store: store.create()
  }, props));
};

Provider.displayName = 'withStore(Provider)';
export default Provider;