/**
 * Local imports
 */
import lookbook from './lookbook';
import store from './store';
import useDispatch from './use-dispatch';
import * as helpers from './helpers';
export default (function (name) {
  var actions = {};
  var dispatch = useDispatch(name);

  if (lookbook.actions[name]) {
    Object.keys(lookbook.actions[name]).forEach(function (actionName) {
      actions[actionName] = function () {
        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return new Promise(function (resolve) {
          var actionType = "@@" + name + "/" + helpers.toSnakeCase(actionName).toUpperCase() + "/COMPLETE";

          var listener = function listener() {
            store.unsubscribe(actionType, listener);
            resolve();
          };

          store.subscribe(actionType, listener);
          dispatch.apply(void 0, [actionName].concat(args));
        });
      };
    });
  }

  return actions;
});