/**
 * Dependency imports
 */
import { useEffect } from 'react';
/**
 * Local imports
 */

import store from './store';
import * as helpers from './helpers';
export default (function (actionType, handler) {
  var targetActionType = actionType;

  if (/^(.*?)\.(.*?)$/.test(actionType)) {
    var _actionType$split = actionType.split('.'),
        actionPrefix = _actionType$split[0],
        actionSuffix = _actionType$split[1];

    targetActionType = "@@" + actionPrefix + "/" + helpers.toSnakeCase(actionSuffix).toUpperCase();
  }

  useEffect(function () {
    store.subscribe(targetActionType, handler);
    return function () {
      store.unsubscribe(targetActionType, handler);
    };
  }, []);
});