"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _lookbook = _interopRequireDefault(require("./lookbook"));

var _store = _interopRequireDefault(require("./store"));

var _useDispatch = _interopRequireDefault(require("./use-dispatch"));

var helpers = _interopRequireWildcard(require("./helpers"));

/**
 * Local imports
 */
var _default = function _default(name) {
  var actions = {};
  var dispatch = (0, _useDispatch["default"])(name);

  if (_lookbook["default"].actions[name]) {
    Object.keys(_lookbook["default"].actions[name]).forEach(function (actionName) {
      actions[actionName] = function () {
        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return new Promise(function (resolve) {
          var actionType = "@@" + name + "/" + helpers.toSnakeCase(actionName).toUpperCase() + "/COMPLETE";

          var listener = function listener() {
            _store["default"].unsubscribe(actionType, listener);

            resolve();
          };

          _store["default"].subscribe(actionType, listener);

          dispatch.apply(void 0, [actionName].concat(args));
        });
      };
    });
  }

  return actions;
};

exports["default"] = _default;