"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _react = require("react");

var _store = _interopRequireDefault(require("./store"));

var helpers = _interopRequireWildcard(require("./helpers"));

/**
 * Dependency imports
 */

/**
 * Local imports
 */
var _default = function _default(actionType, handler) {
  var targetActionType = actionType;

  if (/^(.*?)\.(.*?)$/.test(actionType)) {
    var _actionType$split = actionType.split('.'),
        actionPrefix = _actionType$split[0],
        actionSuffix = _actionType$split[1];

    targetActionType = "@@" + actionPrefix + "/" + helpers.toSnakeCase(actionSuffix).toUpperCase();
  }

  (0, _react.useEffect)(function () {
    _store["default"].subscribe(targetActionType, handler);

    return function () {
      _store["default"].unsubscribe(targetActionType, handler);
    };
  }, []);
};

exports["default"] = _default;